/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-20 19:08:55 UTC)
 * on 2013-06-23 at 04:16:39 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.books.model;

/**
 * Model definition for Annotation.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Books API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Annotation extends com.google.api.client.json.GenericJson {

  /**
   * Anchor text after excerpt. For requests, if the user bookmarked a screen that has no flowing
   * text on it, then this field should be empty.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String afterSelectedText;

  /**
   * Anchor text before excerpt. For requests, if the user bookmarked a screen that has no flowing
   * text on it, then this field should be empty.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String beforeSelectedText;

  /**
   * Selection ranges sent from the client.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ClientVersionRanges clientVersionRanges;

  /**
   * Timestamp for the created time of this annotation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime created;

  /**
   * Selection ranges for the most recent content version.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private CurrentVersionRanges currentVersionRanges;

  /**
   * User-created data for this annotation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String data;

  /**
   * Indicates that this annotation is deleted.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean deleted;

  /**
   * The highlight style for this annotation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String highlightStyle;

  /**
   * Id of this annotation, in the form of a GUID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Resource type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The layer this annotation is for.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String layerId;

  /**
   * Pages that this annotation spans.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> pageIds;

  /**
   * Excerpt from the volume.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String selectedText;

  /**
   * URL to this resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String selfLink;

  /**
   * Timestamp for the last time this annotation was modified.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private com.google.api.client.util.DateTime updated;

  /**
   * The volume that this annotation belongs to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String volumeId;

  /**
   * Anchor text after excerpt. For requests, if the user bookmarked a screen that has no flowing
   * text on it, then this field should be empty.
   * @return value or {@code null} for none
   */
  public java.lang.String getAfterSelectedText() {
    return afterSelectedText;
  }

  /**
   * Anchor text after excerpt. For requests, if the user bookmarked a screen that has no flowing
   * text on it, then this field should be empty.
   * @param afterSelectedText afterSelectedText or {@code null} for none
   */
  public Annotation setAfterSelectedText(java.lang.String afterSelectedText) {
    this.afterSelectedText = afterSelectedText;
    return this;
  }

  /**
   * Anchor text before excerpt. For requests, if the user bookmarked a screen that has no flowing
   * text on it, then this field should be empty.
   * @return value or {@code null} for none
   */
  public java.lang.String getBeforeSelectedText() {
    return beforeSelectedText;
  }

  /**
   * Anchor text before excerpt. For requests, if the user bookmarked a screen that has no flowing
   * text on it, then this field should be empty.
   * @param beforeSelectedText beforeSelectedText or {@code null} for none
   */
  public Annotation setBeforeSelectedText(java.lang.String beforeSelectedText) {
    this.beforeSelectedText = beforeSelectedText;
    return this;
  }

  /**
   * Selection ranges sent from the client.
   * @return value or {@code null} for none
   */
  public ClientVersionRanges getClientVersionRanges() {
    return clientVersionRanges;
  }

  /**
   * Selection ranges sent from the client.
   * @param clientVersionRanges clientVersionRanges or {@code null} for none
   */
  public Annotation setClientVersionRanges(ClientVersionRanges clientVersionRanges) {
    this.clientVersionRanges = clientVersionRanges;
    return this;
  }

  /**
   * Timestamp for the created time of this annotation.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getCreated() {
    return created;
  }

  /**
   * Timestamp for the created time of this annotation.
   * @param created created or {@code null} for none
   */
  public Annotation setCreated(com.google.api.client.util.DateTime created) {
    this.created = created;
    return this;
  }

  /**
   * Selection ranges for the most recent content version.
   * @return value or {@code null} for none
   */
  public CurrentVersionRanges getCurrentVersionRanges() {
    return currentVersionRanges;
  }

  /**
   * Selection ranges for the most recent content version.
   * @param currentVersionRanges currentVersionRanges or {@code null} for none
   */
  public Annotation setCurrentVersionRanges(CurrentVersionRanges currentVersionRanges) {
    this.currentVersionRanges = currentVersionRanges;
    return this;
  }

  /**
   * User-created data for this annotation.
   * @return value or {@code null} for none
   */
  public java.lang.String getData() {
    return data;
  }

  /**
   * User-created data for this annotation.
   * @param data data or {@code null} for none
   */
  public Annotation setData(java.lang.String data) {
    this.data = data;
    return this;
  }

  /**
   * Indicates that this annotation is deleted.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getDeleted() {
    return deleted;
  }

  /**
   * Indicates that this annotation is deleted.
   * @param deleted deleted or {@code null} for none
   */
  public Annotation setDeleted(java.lang.Boolean deleted) {
    this.deleted = deleted;
    return this;
  }

  /**
   * The highlight style for this annotation.
   * @return value or {@code null} for none
   */
  public java.lang.String getHighlightStyle() {
    return highlightStyle;
  }

  /**
   * The highlight style for this annotation.
   * @param highlightStyle highlightStyle or {@code null} for none
   */
  public Annotation setHighlightStyle(java.lang.String highlightStyle) {
    this.highlightStyle = highlightStyle;
    return this;
  }

  /**
   * Id of this annotation, in the form of a GUID.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * Id of this annotation, in the form of a GUID.
   * @param id id or {@code null} for none
   */
  public Annotation setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Resource type.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Resource type.
   * @param kind kind or {@code null} for none
   */
  public Annotation setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The layer this annotation is for.
   * @return value or {@code null} for none
   */
  public java.lang.String getLayerId() {
    return layerId;
  }

  /**
   * The layer this annotation is for.
   * @param layerId layerId or {@code null} for none
   */
  public Annotation setLayerId(java.lang.String layerId) {
    this.layerId = layerId;
    return this;
  }

  /**
   * Pages that this annotation spans.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getPageIds() {
    return pageIds;
  }

  /**
   * Pages that this annotation spans.
   * @param pageIds pageIds or {@code null} for none
   */
  public Annotation setPageIds(java.util.List<java.lang.String> pageIds) {
    this.pageIds = pageIds;
    return this;
  }

  /**
   * Excerpt from the volume.
   * @return value or {@code null} for none
   */
  public java.lang.String getSelectedText() {
    return selectedText;
  }

  /**
   * Excerpt from the volume.
   * @param selectedText selectedText or {@code null} for none
   */
  public Annotation setSelectedText(java.lang.String selectedText) {
    this.selectedText = selectedText;
    return this;
  }

  /**
   * URL to this resource.
   * @return value or {@code null} for none
   */
  public java.lang.String getSelfLink() {
    return selfLink;
  }

  /**
   * URL to this resource.
   * @param selfLink selfLink or {@code null} for none
   */
  public Annotation setSelfLink(java.lang.String selfLink) {
    this.selfLink = selfLink;
    return this;
  }

  /**
   * Timestamp for the last time this annotation was modified.
   * @return value or {@code null} for none
   */
  public com.google.api.client.util.DateTime getUpdated() {
    return updated;
  }

  /**
   * Timestamp for the last time this annotation was modified.
   * @param updated updated or {@code null} for none
   */
  public Annotation setUpdated(com.google.api.client.util.DateTime updated) {
    this.updated = updated;
    return this;
  }

  /**
   * The volume that this annotation belongs to.
   * @return value or {@code null} for none
   */
  public java.lang.String getVolumeId() {
    return volumeId;
  }

  /**
   * The volume that this annotation belongs to.
   * @param volumeId volumeId or {@code null} for none
   */
  public Annotation setVolumeId(java.lang.String volumeId) {
    this.volumeId = volumeId;
    return this;
  }

  @Override
  public Annotation set(String fieldName, Object value) {
    return (Annotation) super.set(fieldName, value);
  }

  @Override
  public Annotation clone() {
    return (Annotation) super.clone();
  }

  /**
   * Selection ranges sent from the client.
   */
  public static final class ClientVersionRanges extends com.google.api.client.json.GenericJson {

    /**
     * Range in CFI format for this annotation sent by client.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange cfiRange;

    /**
     * Content version the client sent in.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String contentVersion;

    /**
     * Range in GB image format for this annotation sent by client.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange gbImageRange;

    /**
     * Range in GB text format for this annotation sent by client.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange gbTextRange;

    /**
     * Range in image CFI format for this annotation sent by client.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange imageCfiRange;

    /**
     * Range in CFI format for this annotation sent by client.
     * @return value or {@code null} for none
     */
    public BooksAnnotationsRange getCfiRange() {
      return cfiRange;
    }

    /**
     * Range in CFI format for this annotation sent by client.
     * @param cfiRange cfiRange or {@code null} for none
     */
    public ClientVersionRanges setCfiRange(BooksAnnotationsRange cfiRange) {
      this.cfiRange = cfiRange;
      return this;
    }

    /**
     * Content version the client sent in.
     * @return value or {@code null} for none
     */
    public java.lang.String getContentVersion() {
      return contentVersion;
    }

    /**
     * Content version the client sent in.
     * @param contentVersion contentVersion or {@code null} for none
     */
    public ClientVersionRanges setContentVersion(java.lang.String contentVersion) {
      this.contentVersion = contentVersion;
      return this;
    }

    /**
     * Range in GB image format for this annotation sent by client.
     * @return value or {@code null} for none
     */
    public BooksAnnotationsRange getGbImageRange() {
      return gbImageRange;
    }

    /**
     * Range in GB image format for this annotation sent by client.
     * @param gbImageRange gbImageRange or {@code null} for none
     */
    public ClientVersionRanges setGbImageRange(BooksAnnotationsRange gbImageRange) {
      this.gbImageRange = gbImageRange;
      return this;
    }

    /**
     * Range in GB text format for this annotation sent by client.
     * @return value or {@code null} for none
     */
    public BooksAnnotationsRange getGbTextRange() {
      return gbTextRange;
    }

    /**
     * Range in GB text format for this annotation sent by client.
     * @param gbTextRange gbTextRange or {@code null} for none
     */
    public ClientVersionRanges setGbTextRange(BooksAnnotationsRange gbTextRange) {
      this.gbTextRange = gbTextRange;
      return this;
    }

    /**
     * Range in image CFI format for this annotation sent by client.
     * @return value or {@code null} for none
     */
    public BooksAnnotationsRange getImageCfiRange() {
      return imageCfiRange;
    }

    /**
     * Range in image CFI format for this annotation sent by client.
     * @param imageCfiRange imageCfiRange or {@code null} for none
     */
    public ClientVersionRanges setImageCfiRange(BooksAnnotationsRange imageCfiRange) {
      this.imageCfiRange = imageCfiRange;
      return this;
    }

    @Override
    public ClientVersionRanges set(String fieldName, Object value) {
      return (ClientVersionRanges) super.set(fieldName, value);
    }

    @Override
    public ClientVersionRanges clone() {
      return (ClientVersionRanges) super.clone();
    }

  }

  /**
   * Selection ranges for the most recent content version.
   */
  public static final class CurrentVersionRanges extends com.google.api.client.json.GenericJson {

    /**
     * Range in CFI format for this annotation for version above.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange cfiRange;

    /**
     * Content version applicable to ranges below.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String contentVersion;

    /**
     * Range in GB image format for this annotation for version above.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange gbImageRange;

    /**
     * Range in GB text format for this annotation for version above.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange gbTextRange;

    /**
     * Range in image CFI format for this annotation for version above.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private BooksAnnotationsRange imageCfiRange;

    /**
     * Range in CFI format for this annotation for version above.
     * @return value or {@code null} for none
     */
    public BooksAnnotationsRange getCfiRange() {
      return cfiRange;
    }

    /**
     * Range in CFI format for this annotation for version above.
     * @param cfiRange cfiRange or {@code null} for none
     */
    public CurrentVersionRanges setCfiRange(BooksAnnotationsRange cfiRange) {
      this.cfiRange = cfiRange;
      return this;
    }

    /**
     * Content version applicable to ranges below.
     * @return value or {@code null} for none
     */
    public java.lang.String getContentVersion() {
      return contentVersion;
    }

    /**
     * Content version applicable to ranges below.
     * @param contentVersion contentVersion or {@code null} for none
     */
    public CurrentVersionRanges setContentVersion(java.lang.String contentVersion) {
      this.contentVersion = contentVersion;
      return this;
    }

    /**
     * Range in GB image format for this annotation for version above.
     * @return value or {@code null} for none
     */
    public BooksAnnotationsRange getGbImageRange() {
      return gbImageRange;
    }

    /**
     * Range in GB image format for this annotation for version above.
     * @param gbImageRange gbImageRange or {@code null} for none
     */
    public CurrentVersionRanges setGbImageRange(BooksAnnotationsRange gbImageRange) {
      this.gbImageRange = gbImageRange;
      return this;
    }

    /**
     * Range in GB text format for this annotation for version above.
     * @return value or {@code null} for none
     */
    public BooksAnnotationsRange getGbTextRange() {
      return gbTextRange;
    }

    /**
     * Range in GB text format for this annotation for version above.
     * @param gbTextRange gbTextRange or {@code null} for none
     */
    public CurrentVersionRanges setGbTextRange(BooksAnnotationsRange gbTextRange) {
      this.gbTextRange = gbTextRange;
      return this;
    }

    /**
     * Range in image CFI format for this annotation for version above.
     * @return value or {@code null} for none
     */
    public BooksAnnotationsRange getImageCfiRange() {
      return imageCfiRange;
    }

    /**
     * Range in image CFI format for this annotation for version above.
     * @param imageCfiRange imageCfiRange or {@code null} for none
     */
    public CurrentVersionRanges setImageCfiRange(BooksAnnotationsRange imageCfiRange) {
      this.imageCfiRange = imageCfiRange;
      return this;
    }

    @Override
    public CurrentVersionRanges set(String fieldName, Object value) {
      return (CurrentVersionRanges) super.set(fieldName, value);
    }

    @Override
    public CurrentVersionRanges clone() {
      return (CurrentVersionRanges) super.clone();
    }

  }

}
